--- 

stages: 
  - Unitest
  - Package
  - Build_push
  - Test
  - Sonarcloud-check

Unitest:
  stage: Unitest
  image:
    name: python:3.8
  before_script:
    - pip install --upgrade pip
    - pip install -r requirements.txt
    - pip install pytest
  script:
    - python manage.py test menu.tests.MenuViewTest main.tests.MainViewTest



Package: 
  stage: Package
  image: 
    name: debian:latest
  before_script:
    - apt update
    - apt upgrade -y
    - apt install git -y
  script:
    - git config --global user.email "$EMAIL"
    - git config --global user.name "$NAME"
    - git config --list
    - git clone https://gitlab.com/ramy.devops/application.git
    - cd application/ 
    - git checkout -- main
    - tar -czvf Projet.tar.gz db.sqlite3 main/ manage.py menu/ PizzaDjango/
    - git remote set-url origin https://oauth2:$TOKEN@gitlab.com/$NAME/application.git
    - git add Projet.tar.gz
    - git commit -m "Ajout de Projet.tar.gz [skip ci]"
    - git push

Build_push:
  stage: Build_push
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker build -t $DOCKERHUB_USERNAME/app_projetc .
    - docker tag $DOCKERHUB_USERNAME/app_projetc $DOCKERHUB_USERNAME/app_projetc:v2
    - echo "$DOCKERHUB_PASSWORD" | docker login -u "$DOCKERHUB_USERNAME" --password-stdin
    - docker push $DOCKERHUB_USERNAME/app_projetc:v2

Test: 
  stage: Test
  image: 
    name: debian:latest
  before_script:
    - apt update
    - apt install curl ca-certificates gnupg lsb-release -y
    - apt install jq -y
    - apt install git -y
    - apt install wget -y
    # - mkdir -m 0755 -p /etc/apt/keyrings 
    # - curl -fsSL https://download.docker.com/linux/debian/gpg |  gpg --dearmor -o /etc/apt/keyrings/docker.gpg
    # - echo "deb [arch=$(dpkg --print-architecture) signed-by=/etc/apt/keyrings/docker.gpg] https://download.docker.com/linux/debian $(lsb_release -cs) stable" | tee /etc/apt/sources.list.d/docker.list > /dev/null
    # - chmod a+r /etc/apt/keyrings/docker.gpg
    # - apt update
    # - apt-get install docker-ce docker-ce-cli containerd.io docker-buildx-plugin docker-compose-plugin -y
    # - git clone https://github.com/arminc/clair-scanner.git
    # - cd clair-scanner
    # - apt-get install build-essential -y
    # - make build
    # - make installLocal
    # - apt install docker -y
    # - wget https://go.dev/dl/go1.20.2.linux-amd64.tar.gz
    # - tar -C /usr/local -xzf go1.20.2.linux-amd64.tar.gz
    # - echo 'export PATH=$PATH:/usr/local/go/bin' >> ~/.bashrc
    # - source ~/.bashrc
    - curl -sSfL https://raw.githubusercontent.com/anchore/grype/main/install.sh | sh -s -- -b /usr/local/bin
  script:
    # - docker pull florjuss/app_projetc
    - grype florjuss/pizza-django #-o json | jq '.[]'

variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
sonarcloud-check:
  stage: Sonarcloud-check
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner







